/*
 * Launcher.java
 *
 *
 * Created on June 9, 2006, 4:06 AM
 */

package sddm;
import java.awt.event.WindowEvent;
import java.lang.reflect.Modifier;
import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.text.*;
import javax.media.opengl.*;
import net.java.joglutils.*;
import sddm.modules.*;
import sddm.*;

/**
 *
 * @author  Erik J. Tollerud
 */
public class Launcher extends javax.swing.JPanel {
    private java.awt.Window launchingWindow;
    private boolean modal, defaultModsOn;
    private Color rightAnaglyphColor, leftAnaglyphColor;
    
    /**
     * Creates new form Launcher
     * 
     * @param defaultModsOn determines if the built-in modules should be loaded on generation of this Launcher
     * @param modal true to generate a modal Launcher dialog, false for multilaunch frame
     */
    public Launcher(boolean modal,boolean defaultModsOn) {
        this.defaultModsOn = defaultModsOn;
        initComponents();
        setModal(modal);
        this.defaultModsOn = defaultModsOn;
        rightAnaglyphColor = new Color(1.0f,0,0);
        leftAnaglyphColor = new Color(0,0,1.0f);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        stereoMethodGroup = new javax.swing.ButtonGroup();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        moduleComboBox = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        GLRadioButton = new javax.swing.JRadioButton();
        dualRadioButton = new javax.swing.JRadioButton();
        anaglyphRadioButton = new javax.swing.JRadioButton();
        anaglyphButton = new javax.swing.JButton();
        noStereoRadioButton = new javax.swing.JRadioButton();
        debugCheckBox = new javax.swing.JCheckBox();
        moduleSetupContainerPanel = new javax.swing.JPanel();
        displayListCheckBox = new javax.swing.JCheckBox();
        multiSampleComboBox = new javax.swing.JComboBox();
        aboutButton = new javax.swing.JButton();

        setPreferredSize(new java.awt.Dimension(420, 440));
        okButton.setText("Ok");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        moduleComboBox.setModel(new ModuleClassComboBoxModel(this.defaultModsOn));
        moduleComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                moduleComboBoxActionPerformed(evt);
            }
        });

        jLabel2.setText("Module Type");

        jLabel3.setText("Stereo Method");

        stereoMethodGroup.add(GLRadioButton);
        GLRadioButton.setText("OpenGL Stereo");
        GLRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        GLRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        stereoMethodGroup.add(dualRadioButton);
        dualRadioButton.setText("Dual Window");
        dualRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        dualRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        stereoMethodGroup.add(anaglyphRadioButton);
        anaglyphRadioButton.setText("Anaglyph");
        anaglyphRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        anaglyphRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        anaglyphButton.setText("Anaglyph Colors...");
        anaglyphButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                anaglyphButtonActionPerformed(evt);
            }
        });

        stereoMethodGroup.add(noStereoRadioButton);
        noStereoRadioButton.setSelected(true);
        noStereoRadioButton.setText("None");
        noStereoRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        noStereoRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        debugCheckBox.setText("Debug Mode?");
        debugCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        debugCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        displayListCheckBox.setSelected(true);
        displayListCheckBox.setText("Display List?");
        displayListCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        displayListCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        multiSampleComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "No AA/MS", "2X", "4X", "8X", "16X" }));

        aboutButton.setText("About...");
        aboutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, moduleSetupContainerPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel3)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(anaglyphButton)
                            .add(layout.createSequentialGroup()
                                .add(GLRadioButton)
                                .add(24, 24, 24)
                                .add(dualRadioButton)
                                .add(35, 35, 35)
                                .add(anaglyphRadioButton)))
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(20, 20, 20)
                                .add(noStereoRadioButton))
                            .add(layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(aboutButton)
                                    .add(multiSampleComboBox, 0, 102, Short.MAX_VALUE)))))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(91, 91, 91)
                                .add(okButton))
                            .add(layout.createSequentialGroup()
                                .add(debugCheckBox)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(displayListCheckBox)))
                        .add(31, 31, 31)
                        .add(cancelButton)
                        .add(97, 97, 97))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel2)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, moduleComboBox, 0, 400, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel2)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(moduleComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(moduleSetupContainerPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 271, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel3)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(GLRadioButton)
                    .add(dualRadioButton)
                    .add(anaglyphRadioButton)
                    .add(noStereoRadioButton))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(debugCheckBox)
                    .add(displayListCheckBox)
                    .add(anaglyphButton)
                    .add(multiSampleComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(cancelButton)
                    .add(okButton)
                    .add(aboutButton))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void aboutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutButtonActionPerformed
        final String[] glInfo = new String[3]; 
        final String introStr = "About SDDM 2 (Java Implementation)...\n" +
                "Author:Erik J. Tollerud\n"+"OpenGL Information:\n";
        final JTextArea jta = new JTextArea(5,65);
        jta.setText(introStr);
        
        javax.media.opengl.GLJPanel gljp = new javax.media.opengl.GLJPanel();
        gljp.addGLEventListener( new javax.media.opengl.GLEventListener() {
            public void display(GLAutoDrawable drawable) {
            }
            public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged) {
            }
            public void init(GLAutoDrawable drawable) {
                GL gl = drawable.getGL();
                glInfo[0] = "GL_VENDOR: " + gl.glGetString(GL.GL_VENDOR);
                glInfo[1] = "GL_RENDERER: " + gl.glGetString(GL.GL_RENDERER);
                glInfo[2] = "GL_VERSION: " + gl.glGetString(GL.GL_VERSION);
                String str = introStr;
                for(String s : glInfo)
                    str+=(s+'\n');
                jta.setText(str);
                jta.repaint();
            }
            public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
            }
        });
        gljp.setSize(1,1);
        
        javax.swing.JPanel panel = new javax.swing.JPanel();
        panel.add(jta);
        panel.add(gljp);
        net.java.joglutils.JPanelDialog jpd = new net.java.joglutils.JPanelDialog("About SDDM",panel);
        jpd.setSize(jpd.getPreferredSize().width+40,jpd.getPreferredSize().height+50);
        jpd.showAsModal();
        
    }//GEN-LAST:event_aboutButtonActionPerformed
    
    private void moduleComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_moduleComboBoxActionPerformed
        SDDModuleSetupPanel moduleSetupPanel = null;
        
        Class moduleClass = ((ModuleClassWithTitle) moduleComboBox.getSelectedItem()).getModuleClass();
        java.lang.reflect.Method nsp;
        try{
            nsp = moduleClass.getMethod("newStartupPanel");
            moduleSetupPanel = (SDDModuleSetupPanel) nsp.invoke(null);
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this,"Exception "+e.getClass().getName()+" thrown while trying to make new panel:"+e,"Exception thrown",JOptionPane.ERROR_MESSAGE);
            moduleSetupPanel = null;
        }
        
        this.moduleSetupContainerPanel.removeAll();
        
        if (moduleSetupPanel!=null) {
            
            this.moduleSetupContainerPanel.setPreferredSize(moduleSetupPanel.getPreferredSize());
            this.moduleSetupContainerPanel.add(moduleSetupPanel);
        } else
            this.moduleSetupContainerPanel.setPreferredSize(new Dimension(0,0));
        
        //TODO: make the size correct
        this.moduleSetupContainerPanel.validate();
        this.moduleSetupContainerPanel.repaint();
    }//GEN-LAST:event_moduleComboBoxActionPerformed
    
    private void anaglyphButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_anaglyphButtonActionPerformed
        JColorChooser chooser = new JColorChooser();
        Color l = chooser.showDialog(this,"Left Color",leftAnaglyphColor);
        if (l!=null) {
            leftAnaglyphColor = l;
            Color r = chooser.showDialog(this,"Right Color",rightAnaglyphColor);
            if (r!=null)
                rightAnaglyphColor = r;
        }
    }//GEN-LAST:event_anaglyphButtonActionPerformed
    
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        System.exit(0);
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        
        try {
            launchModule();
            if (this.isModal())
                launchingWindow.dispose();
        } catch (Exception e) {
            e.printStackTrace();
            JOptionPane.showMessageDialog(this, "Not launching due to exception(see console stack trace):\n"+e,"SDDMException",JOptionPane.ERROR_MESSAGE);
        } /*TODO: bring back in if the fix can be worked with addLibraryPath
         catch (Error e) {
            e.printStackTrace();
            String result = JOptionPane.showInputDialog("path");
            addLibraryPath(result);
            okButtonActionPerformed(evt);
        }*/
        
    }//GEN-LAST:event_okButtonActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton GLRadioButton;
    private javax.swing.JButton aboutButton;
    private javax.swing.JButton anaglyphButton;
    private javax.swing.JRadioButton anaglyphRadioButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JCheckBox debugCheckBox;
    private javax.swing.JCheckBox displayListCheckBox;
    private javax.swing.JRadioButton dualRadioButton;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JComboBox moduleComboBox;
    private javax.swing.JPanel moduleSetupContainerPanel;
    private javax.swing.JComboBox multiSampleComboBox;
    private javax.swing.JRadioButton noStereoRadioButton;
    private javax.swing.JButton okButton;
    private javax.swing.ButtonGroup stereoMethodGroup;
    // End of variables declaration//GEN-END:variables
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        //process command line arguments for look-and-feel option and library location; switches processed:
        //[-laf] default|native|motif|crossplatform|<custom>
        //[-native|nativelib|nativeLib] location
        //[-glversion]     (note: this will exit upon returning version information)
        
        //For windows: set sun.java2d.noddraw to true (replaces command line -Dsun.java2d.noddraw=true)
        String osName = System.getProperty("os.name");
        if (isWindows(osName))
            System.setProperty("sun.java2d.noddraw","true");
        
        boolean defaultModsOn = true;
        try {
            //Set default look-and-feel to builtin
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
            for (int i = 0 ; i < args.length;++i) {
                
                if (args[i].equalsIgnoreCase("-glversion")) {
                    //check for opengl version information
                    final boolean[] readyToExit = {false};
                    
                    GLEventListener listener = new GLEventListener() {
                        public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
                        }
                        
                        public void init(GLAutoDrawable drawable) {
                            GL gl = drawable.getGL();
                            String vn = gl.glGetString(gl.GL_VERSION);
                            String rn = gl.glGetString(gl.GL_RENDERER);
                            String vd = gl.glGetString(gl.GL_VENDOR);
                            boolean shader = gl.isFunctionAvailable("glUseProgramObjectARB")||gl.isFunctionAvailable("glUseProgramObject");
                            
                            
                            StringBuffer sb = new StringBuffer();
                            sb.append("GL_VERSION: ");
                            sb.append(vn);
                            sb.append("\n");
                            sb.append("GL_RENDERER: ");
                            sb.append(rn);
                            sb.append("\n");
                            sb.append("GL_VENDOR: ");
                            sb.append(vd);
                            sb.append("\n");
                            sb.append("Shaders Supported? ");
                            sb.append(shader?"Yes":"No");
                            System.out.println(sb.toString());
                            JOptionPane.showMessageDialog(null,sb.toString(),"OpenGL Version Information",JOptionPane.INFORMATION_MESSAGE);
                            readyToExit[0] = true;
                        }
                        
                        public void display(GLAutoDrawable drawable) {
                        }
                        
                        public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged) {
                        }
                        
                    };
                    if (GLDrawableFactory.getFactory().canCreateGLPbuffer()) {
                        GLPbuffer glpb = GLDrawableFactory.getFactory().createGLPbuffer(new GLCapabilities(),new DefaultGLCapabilitiesChooser(),1,1,null);
                        glpb.addGLEventListener(listener);
                        glpb.repaint();
                        
                    } else {
                        net.java.joglutils.GLJFrame gljf = new net.java.joglutils.GLJFrame(listener);
                        gljf.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
                        gljf.setVisible(true);
                    }
                    
                    while (!readyToExit[0])
                        Thread.currentThread().wait(250);//don't over-use processor
                    System.exit(0);
                }
                
                else if (args[i].equals("-laf")) {
                    String type = args[++i];
                    if (type.equalsIgnoreCase("default"));
                    else if (type.equalsIgnoreCase("crossplatform")||type.equalsIgnoreCase("cp")||type.equalsIgnoreCase("metal"))
                        UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
                    else if (type.equalsIgnoreCase("native")||type.equalsIgnoreCase("local"))
                        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                    else if (type.equalsIgnoreCase("motif"))
                        UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
                    else {
                        UIManager.LookAndFeelInfo[] lafia = UIManager.getInstalledLookAndFeels();
                        for (UIManager.LookAndFeelInfo lafi: lafia) {
                            if(lafi.getName().equalsIgnoreCase(type))
                                type = lafi.getClassName();
                        }
                    }
                }
                
                else if (args[i].equals("-native")||args[i].equals("-nativelib")||args[i].equals("-nativeLib")) {
                    try {
                        File loc = new File(args[i+1]);
                        loadJOGLibraries(loc);
                    } catch(Exception e) {
                        throw new ParsingException(e.getMessage(),e);
                    }
                }
                else if (args[i].equals("-nodefaultmods")) {
                    defaultModsOn = false;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Error setting "+ ((e instanceof ParsingException) ? "library location" : "Look-and-Feel") +":"+e.getMessage()+"\nExiting...");
            System.exit(0);
        }
        
        setupNativeLibs();
        
        
        
        final Launcher ln = new Launcher(false,defaultModsOn);
        try {
            HashMap<String,Integer> switchMap = ln.parseArgs(args);
            
            if (switchMap == null)
                java.awt.EventQueue.invokeLater(new Runnable() {
                    public void run() {
                        ln.showWindow();
                    }
                });
            else {
                try {
                    ln.launchModule(switchMap, args);
                    if (switchMap.size()!=0) {
                        StringBuffer message = new StringBuffer("Some Switches unprocessed:");
                        for(String s : switchMap.keySet()) {
                            message.append(" ");
                            message.append(s);
                        }
                        throw new SDDMException(message.toString());
                    }
                } catch (UnsatisfiedLinkError e) {
                    JOptionPane.showMessageDialog(null,"Could not find JOGL native Libraries.  Exiting...","JOGL Natives not Found",JOptionPane.ERROR_MESSAGE);
                    System.exit(1);
                }
                
            }
        } catch (ParsingException e) {
            e.printStackTrace();
            System.err.println("Could not parse command line options - exiting...");
            System.exit(0);
        }
    }
    
    SDDModule argsMod;
    GLCapabilities argsCaps;
    SDDMListener.StereoMethod argsMethod = SDDMListener.StereoMethod.NONE;
    StereoCamera argsCam;
    boolean argsDebug = false;
    
    /**
     * Parses command-line arguments, building a HashMap of switches and their associated indecies<br>
     * also processes switches that are not part of launching the module
     *
     * @return true if the arguments specify that the GUI selector should be shown
     * @param args command line arguments
     * @throws sddm.ParsingException if the command line couldn't be parsed
     */
    public HashMap<String,Integer> parseArgs(String[] args) throws ParsingException {
        //arguments accepted here:
        //[-laf] crossplatform|cp|native|local|motif (parsed before this loop)
        //These arguments are processed if there's no module to launch from
        //[-modal] (true|t)|(false|f)
        //[-aa|ms] numOfSamples
        //[-sm|stereomethod|stereo] a|anaglyph|opengl|builtin|d|dual|dualwindow|dw|n|none
        //[-leftcolor] r g b
        //[-rightcolor] r g b
        //[-displaylist|dl] (true|t)|(false|f)
        //[-debug]
        //[-addmod|modclass] className [className2] [className3] [...]
        
        
        HashMap<String,Integer> switchMap = new HashMap<String,Integer>();
        
        //builds a dictionary of all the arguments that are switches (i.e. have
        for(int i = 0; i < args.length; ++i) {
            if (args[i].charAt(0)=='-')
                switchMap.put(args[i],i);
        }
        switchMap.remove("-laf");
        //first try to add classes
        
        Integer amodIndx = switchMap.remove("-addmod");
        if (amodIndx == null)
            amodIndx = switchMap.remove("-modclass");
        if (amodIndx != null) {
            for(int i = 1; amodIndx+i < args.length && args[amodIndx+i].charAt(0) != '-' ;++i) {
                try {
                    this.addModuleType(args[amodIndx+i]);
                } catch (ClassNotFoundException e) {
                    throw new ParsingException("Could not load class "+ args[amodIndx+i]+" . Note: classes are case sensitive and must be full names (i.e. sddm.module.TestModule)",e);
                }
            }
        }
        
        
        if(switchMap.remove("-native")==null) {
            if (switchMap.remove("-nativelib")==null)
                switchMap.remove("-nativeLib");
        }
        
        
        
        Integer modalIndx = switchMap.remove("-modal");
        if (modalIndx != null) {
            if (modalIndx+1 < args.length && !switchMap.containsKey(args[modalIndx+1])){
                String modalStr = args[modalIndx+1];
                if (modalStr.matches("true|t"))
                    this.setModal(true);
                else if (modalStr.matches("false|f"))
                    this.setModal(false);
                else
                    throw new ParsingException("unrecognized modality setting:"+modalStr);
            } else
                this.setModal(true);
        }
        
        //ADD: parse any appropriate other switches and then remove from switchMap
        
        if(!switchMap.containsKey("-mod")) {
            //get switches to set up launcher if there's no module
            
            Integer aaIndex = switchMap.remove("-aa");
            if (aaIndex == null)
                aaIndex = switchMap.remove("-ms");
            Integer smIndex = switchMap.remove("-sm");
            if (smIndex == null)
                smIndex = switchMap.remove("-stereomethod");
            if (smIndex == null)
                smIndex = switchMap.remove("-stereo");
            Integer dlIndex = switchMap.remove("-dl");
            if (dlIndex == null)
                dlIndex = switchMap.remove("-displaylist");
            Integer lcIndex = switchMap.remove("-leftcolor");
            Integer rcIndex = switchMap.remove("-rightcolor");
            boolean debug = (switchMap.remove("-debug") != null);
            
            //configure launcher from these switches
            if (aaIndex != null) {
                String aaStr = args[aaIndex+1];
                switch(Integer.parseInt(aaStr)) {
                    case 0:
                        this.multiSampleComboBox.setSelectedIndex(0);
                        break;
                    case 2:
                        this.multiSampleComboBox.setSelectedIndex(1);
                        break;
                    case 4:
                        this.multiSampleComboBox.setSelectedIndex(2);
                        break;
                    case 8:
                        this.multiSampleComboBox.setSelectedIndex(3);
                        break;
                    case 16:
                        this.multiSampleComboBox.setSelectedIndex(4);
                        break;
                    default:
                        throw new ParsingException("invalid sample number for aa/ms switch");
                }
                
            }
            if(smIndex != null) {
                String methodString = args[smIndex+1];
                if (methodString.matches("a|anaglyph")) {
                    this.anaglyphRadioButton.setSelected(true);
                }
                if (methodString.matches("opengl|builtin")) {
                    this.GLRadioButton.setSelected(true);
                }
                if (methodString.matches("d|dual|dualwindow|dw")) {
                    this.dualRadioButton.setSelected(true);
                }
                if (methodString.equalsIgnoreCase("n|none")) {
                    this.noStereoRadioButton.setSelected(true);
                }
            }
            if (dlIndex != null) {
                String dlString = args[dlIndex+1];
                if (dlString.matches("true|t"))
                    this.displayListCheckBox.setSelected(true);
                else if (dlString.matches("false|f"))
                    this.displayListCheckBox.setSelected(false);
                else
                    throw new ParsingException("unrecognized display list setting:"+dlString);
            }
            this.debugCheckBox.setSelected(debug);
            if (lcIndex != null) {
                float r = Float.parseFloat(args[lcIndex+1]);
                float g = Float.parseFloat(args[lcIndex+2]);
                float b = Float.parseFloat(args[lcIndex+3]);
                this.leftAnaglyphColor = new Color(r,g,b);
            }
            if (rcIndex != null) {
                float r = Float.parseFloat(args[rcIndex+1]);
                float g = Float.parseFloat(args[rcIndex+2]);
                float b = Float.parseFloat(args[rcIndex+3]);
                this.rightAnaglyphColor = new Color(r,g,b);
            }
            
            //Throw exception if any switches are left over
            if (switchMap.size() != 0) {
                StringBuffer message = new StringBuffer("Some switches unprocessed:");
                for(String s : switchMap.keySet()) {
                    message.append(" ");
                    message.append(s);
                }
                throw new ParsingException(message.toString());
            }
            
            //set the map to null so that the launcher GUI comes up
            switchMap = null;
        }
        return switchMap;
    }
    
    protected static void launchModule(SDDModule mod,
            SDDMListener.StereoMethod method,
            int samples, StereoCamera camera,
            boolean debug,
            boolean displayList,
            Color leftAnaglyphColor,
            Color rightAnaglyphColor,
            boolean exitOnClose) {
        //Default module is test module
        if (mod == null)
            mod = new TestModule(camera);
        //Default capabilities used unless altered
        GLCapabilities caps = new GLCapabilities();
        //Components added to this vector will be shown upon completion of all the setup
        final Vector<java.awt.Component> componentsToShow = new Vector<java.awt.Component>();
        
        
        if (samples == 2 || samples == 4 ||samples == 8 ||samples == 16) {
            caps.setSampleBuffers(true);
            caps.setNumSamples(samples);
        } else
            caps.setSampleBuffers(false);
        
        caps.setAlphaBits(8);
        
        //generate the control panel from the module and generate the control frame
        SDDModuleControlPanel panel = mod.newModuleControlPanel();
        panel.setCamera(camera);
        StereoCameraControlFrame cFrame = new StereoCameraControlFrame(SDDModule.moduleTitle(mod) + " Control Panel", panel, camera);
        cFrame.pack();
        componentsToShow.add(cFrame);
        if (exitOnClose)
            cFrame.setDefaultCloseOperation(cFrame.EXIT_ON_CLOSE);
        else
            cFrame.addWindowListener(cFrame.getCloser());
        
        //Choose the selected Stereo method and add any necessary GLJFrames to componentsToShow
        SDDMListener listener = null;
        switch (method) {
            case OPENGL:
                //OpenGL Stereo mode
                listener = new SDDMListener(mod,SDDMListener.StereoMethod.OPENGL,camera);
                listener.setDebugEnabled(debug);
                
                caps.setStereo(true);
                GLJFrame fm = new GLJFrame(SDDModule.moduleTitle(mod),listener,caps, new SDDMChooser());
                cFrame.attachFrame(fm);
                componentsToShow.add(fm);
                if (exitOnClose)
                    fm.setDefaultCloseOperation(fm.EXIT_ON_CLOSE);
                else
                    fm.addWindowListener(cFrame.getCloser());
                break;
                
            case DUAL_WINDOW_LEFT:
            case DUAL_WINDOW_RIGHT:
                //Dual window mode
                
                SDDMListener listenerLeft = new SDDMListener(mod,SDDMListener.StereoMethod.DUAL_WINDOW_LEFT,camera);
                SDDMListener listenerRight = new SDDMListener(mod,SDDMListener.StereoMethod.DUAL_WINDOW_RIGHT,camera);
                if(debug) {
                    listenerLeft.setDebugEnabled(true);
                    listenerRight.setDebugEnabled(true);
                }
                //TODO: try to do this with context-sharing
                GLJFrame fml = new GLJFrame(SDDModule.moduleTitle(mod)+" - Left",listenerLeft,caps, new SDDMChooser());
                //fml.setVisible(true);
                //GLJFrame fmr = new GLJFrame(SDDModule.moduleTitle(mod)+" - Right",listenerRight,caps,fml.getContext());
                GLJFrame fmr = new GLJFrame(SDDModule.moduleTitle(mod)+" - Right",listenerRight,caps, new SDDMChooser());
                componentsToShow.add(fml);
                componentsToShow.add(fmr);
                if (exitOnClose) {
                    fml.setDefaultCloseOperation(fml.EXIT_ON_CLOSE);
                    fmr.setDefaultCloseOperation(fmr.EXIT_ON_CLOSE);
                } else {
                    fml.addWindowListener(cFrame.getCloser());
                    fmr.addWindowListener(cFrame.getCloser());
                }
                cFrame.attachFrame(fml);
                cFrame.attachFrame(fmr);
                break;
            case ANAGLYPH:
                //Anaglyph mode
                listener = new SDDMListener(mod,SDDMListener.StereoMethod.ANAGLYPH,camera);
            case ANAGLYPH_FORCE_BASIC:
                if (listener == null)
                    listener = new SDDMListener(mod,SDDMListener.StereoMethod.ANAGLYPH_FORCE_BASIC,camera);
                
                listener.setDebugEnabled(debug);
                
                listener.setAnaglyphLeftColor(leftAnaglyphColor);
                listener.setAnaglyphRightColor(rightAnaglyphColor);
                fm = new GLJFrame(SDDModule.moduleTitle(mod),listener,caps, new SDDMChooser());
                cFrame.attachFrame(fm);
                componentsToShow.add(fm);
                if (exitOnClose)
                    fm.setDefaultCloseOperation(fm.EXIT_ON_CLOSE);
                else
                    fm.addWindowListener(cFrame.getCloser());
                
                mod.setBackgroundColor(new Color(0.0f,0.0f,0.0f,1.0f));
                break;
            case NONE:
            default:
                //No stereo mode
                camera.setMode(StereoCamera.StereoMode.FRUSTUM_NO_STEREO);
                listener = new SDDMListener(mod,SDDMListener.StereoMethod.NONE,camera);
                listener.setDebugEnabled(debug);
                
                fm = new GLJFrame(SDDModule.moduleTitle(mod),listener,caps, new SDDMChooser());
                
                cFrame.attachFrame(fm);
                componentsToShow.add(fm);
                if (exitOnClose)
                    fm.setDefaultCloseOperation(fm.EXIT_ON_CLOSE);
                else
                    fm.addWindowListener(cFrame.getCloser());
        }
        
        //attach event listeners to the GLJFrames through the control frame
        mod.attachEventListeners(cFrame);
        //set display list mode from check box
        mod.setDisplayListOn(displayList);
        //set control panels based on modules
        mod.configurePanels(cFrame.getControlPanel(),cFrame.getSecondPanel());
        //set sphere size for updater
        camera.sphereSizeOnUpdate = 5.0f*mod.getMinFeatureSizeHint();
        
        //Show all the components in the Vector using the event-dispatch thread
        javax.swing.SwingUtilities.invokeLater( new Runnable() {
            public void run() {
                int lastTop = 0;
                int lastLeft = 0;
                for (Component c : componentsToShow ) {
                    offsetFromUnderlyingFrames(c,Frame.getFrames());
                    c.setVisible(true);
                }
                
            }
        });
        
    }
    
    protected void launchModule() throws NoSuchMethodException, InstantiationException, IllegalAccessException {
        //This should be the only time a new camera is made down the whole chain if the constructors are all fed correctly
        StereoCamera camera = new StereoCamera(StereoCamera.StereoMode.FRUSTUM_STEREO);
        
        SDDModule mod = null;
        
        //Sets number of samples
        int ms = 0;
        switch(this.multiSampleComboBox.getSelectedIndex()) {
            case 1:
                ms = 2;
                break;
            case 2:
                ms = 4;
                break;
            case 3:
                ms = 8;
                break;
            case 4:
                ms = 16;
                break;
        }
        
        //Retrieves module settings from the setup panel connected to the launcher
        try {
            SDDModuleSetupPanel sp = (SDDModuleSetupPanel) this.moduleSetupContainerPanel.getComponent(0);
            mod = sp.makeModule(camera);
        } catch (ArrayIndexOutOfBoundsException e1) {
            //If there is no startup panel, instead launch a default instance
            if(e1.getMessage().equals("No such child: 0"))  {
                Class moduleClass = ((ModuleClassWithTitle) moduleComboBox.getSelectedItem()).getModuleClass();
                try {
                    java.lang.reflect.Constructor ctor = moduleClass.getConstructor(StereoCamera.class);
                    mod = (SDDModule) ctor.newInstance(camera);
                    //mod = (SDDModule) moduleClass.newInstance();
                    //mod.setCamera(camera);
                }  catch (java.lang.reflect.InvocationTargetException ex) {
                    throw (RuntimeException) ex.getCause();
                }
            } else
                throw e1;
        }
        
        //Choose the appropriate stereo method
        SDDMListener.StereoMethod method = SDDMListener.StereoMethod.NONE;
        
        if (this.GLRadioButton.isSelected())
            method = SDDMListener.StereoMethod.OPENGL;
        else if (this.dualRadioButton.isSelected())
            method = SDDMListener.StereoMethod.DUAL_WINDOW_LEFT;
        else if (this.anaglyphRadioButton.isSelected()) {
                method = SDDMListener.StereoMethod.ANAGLYPH;
        }
        
        launchModule(mod,method,ms,camera, this.debugCheckBox.isSelected(),this.displayListCheckBox.isSelected(),this.leftAnaglyphColor,this.rightAnaglyphColor,this.isModal());
        
    }
    
    protected void launchModule(HashMap<String,Integer> switchMap, String[] args) throws ParsingException {
        //arguments processed here
        //-mod * (and in the module makeModuleFromArgs)
        //[-aa|ms] numOfSamples
        //[-sm|stereomethod|stereo] a|anaglyph|opengl|builtin|d|dual|dualwindow|dw|n|none
        //[-leftcolor] r g b
        //[-rightcolor] r g b
        //[-displaylist|dl] (true|t)|(false|f)
        //[-debug]
        
        StereoCamera camera = new StereoCamera(StereoCamera.StereoMode.FRUSTUM_STEREO);
        
        Integer modIndex = switchMap.remove("-mod");
        if (modIndex == null)
            throw new ParsingException("tried to launch a module with no -mod switch provided");
        String modName = args[modIndex+1];
        
        SDDModule mod = null;
        ModuleClassComboBoxModel cbm = (ModuleClassComboBoxModel) this.moduleComboBox.getModel();
        for (int i =0; (i < cbm.getSize())&&(mod == null); ++i) {
            //Assuming this is a subclass of SDDModule... if not, something is seriously wrong and many things will crash.
            Class css = cbm.getElementAt(i).getModuleClass();
            try {
                java.lang.reflect.Method meth = null;
                for (java.lang.reflect.Method m : css.getMethods()) {
                    if (m.getName().equals("makeModuleFromArgs"))
                        meth = m;
                }
                if (meth == null) {
                    JOptionPane.showMessageDialog(null,"Couldn't find makeModuleFromArgs method in supplied class - could an invalid module have been provided?\nExiting...", "No comannd line module maker",JOptionPane.ERROR_MESSAGE);
                    System.exit(1);
                }
                // try {
                //java.lang.reflect.Method meth = css.getMethod("makeModuleFromArgs",String.class,HashMap.class,String[].class,StereoCamera.class);
                //java.lang.reflect.Method meth = css.getMethod("makeModuleFromArgs",String.class,HashMap<String,Integer>.class,String[].class,StereoCamera.class);
                //     }catch (NoSuchMethodException e) {
                //    JOptionPane.showMessageDialog(null,"Couldn't find makeModuleFromArgs method - maybe an invalid module was added?:\n"+e+"\n Exiting...","Couldn't make module from command lines",JOptionPane.ERROR_MESSAGE);
                //    System.exit(1);
                //}
                mod = (SDDModule) meth.invoke(null,modName,switchMap,args,camera);
            } catch (java.lang.reflect.InvocationTargetException e) {
                if (e.getCause() instanceof ParsingException)
                    throw (ParsingException)e.getCause();
                else
                    throw (RuntimeException)e.getCause();
            } catch (IllegalAccessException e) {
                JOptionPane.showMessageDialog(null,e+"\n Exiting...", "IllegalAccessException",JOptionPane.ERROR_MESSAGE);
                System.exit(1);
            } catch (IllegalArgumentException e) {
                JOptionPane.showMessageDialog(null,e+"\n Exiting...", "IllegalArgumentException",JOptionPane.ERROR_MESSAGE);
                System.exit(1);
            }
        }
        if (mod == null)
            throw new ParsingException("Could not find a module to match the requested name:"+modName);
        
        //process switches common to all modules
        boolean debug = (switchMap.remove("-debug") != null);
        
        int ms = 0;
        Integer msIndx = switchMap.remove("-aa");
        if (msIndx == null)
            msIndx = switchMap.remove("-ms");
        if (msIndx != null)
            ms = Integer.parseInt(args[msIndx+1]);
        
        if (ms != 0 && ms != 2 && ms != 4 && ms != 8 && ms != 16)
            throw new ParsingException("Invalid number of ms/aa samples: "+ms);
        
        
        boolean displayList = true;
        Integer dlIndx = switchMap.remove("-dl");
        if (dlIndx == null)
            dlIndx = switchMap.remove("-displaylist");
        if (dlIndx != null) {
            String dlStr = args[dlIndx+1];
            if(dlStr.matches("t|true"))
                displayList = true;
            else if(dlStr.matches("f|false"))
                displayList = false;
            else
                throw new ParsingException("Invalid setting for displaylist:"+dlStr);
        }
        
        SDDMListener.StereoMethod method = SDDMListener.StereoMethod.NONE;
        //-sm|stereomethod|stereo a|anaglyph|opengl|builtin|d|dual|dualwindow|dw|n|none
        Integer smIndx = switchMap.remove("-sm");
        if (smIndx == null)
            smIndx = switchMap.remove("-stereomethod");
        if (smIndx == null)
            smIndx = switchMap.remove("-stereo");
        if (smIndx != null) {
            //TODO: make this case insensitive with Pattern
            String smStr = args[smIndx+1];
            if (smStr.matches("a|anaglyph"))
                method = SDDMListener.StereoMethod.ANAGLYPH;
            if (smStr.matches("basicana|basicanaglyph"))
                method = SDDMListener.StereoMethod.ANAGLYPH_FORCE_BASIC;
            else if (smStr.matches("opengl|builtin"))
                method = SDDMListener.StereoMethod.OPENGL;
            else if (smStr.matches("d|dual|dualwindow|dw"))
                method = SDDMListener.StereoMethod.DUAL_WINDOW_LEFT;
            else if (smStr.matches("n|none"))
                method = SDDMListener.StereoMethod.NONE;
        }
        
        Color leftColor = new Color(0.0f,0.0f,1.0f);
        Integer lcIndx = switchMap.remove("-leftcolor");
        if (lcIndx != null) {
            float r = Float.parseFloat(args[lcIndx+1]);
            float g = Float.parseFloat(args[lcIndx+2]);
            float b = Float.parseFloat(args[lcIndx+3]);
            leftColor = new Color(r,g,b);
        }
        
        Color rightColor = new Color(1.0f,0.0f,0.0f);
        Integer rcIndx = switchMap.remove("-rightcolor");
        if (rcIndx != null) {
            float r = Float.parseFloat(args[rcIndx+1]);
            float g = Float.parseFloat(args[rcIndx+2]);
            float b = Float.parseFloat(args[rcIndx+3]);
            rightColor = new Color(r,g,b);
        }
        
        //ADD: any new switches common to all modules should go here - camera settings, perhaps?
        
        launchModule(mod,method,ms,camera,debug,displayList,leftColor,rightColor,true);
        //a check for all the switches being used should occur immediately after this method terminates
    }
    
    public void setModal(boolean b) {
        this.modal = b;
        
        if (b) {
            this.launchingWindow = new javax.swing.JDialog(new javax.swing.JFrame(),"SDDM Launcher",true);
            
            this.okButton.setText("Ok");
            this.cancelButton.setText("Cancel");
        } else {
            this.launchingWindow = new javax.swing.JFrame("SDDM Launcher");
            
            this.okButton.setText("Launch");
            this.cancelButton.setText("Done");
        }
        this.launchingWindow.add(this);
        this.launchingWindow.pack();
        this.launchingWindow.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                super.windowClosing(e);
                System.exit(0);
            }
            
        });
    }
    public boolean isModal() {
        return this.modal;
    }
    
    public void showWindow() {
        launchingWindow.setVisible(true);
    }
    
    public void addModuleType(String className) throws ClassNotFoundException {
        Class c = java.lang.Class.forName(className);
        addModuleType(c);
    }
    
    public void addModuleType(Class module) throws SDDMException {
        if(!SDDModule.class.isAssignableFrom(module))
            throw new SDDMException("Tried to add non-SDDModule class to the installed modules");
        
        ModuleClassComboBoxModel cbm = (ModuleClassComboBoxModel) this.moduleComboBox.getModel();
        cbm.addElement(new ModuleClassWithTitle(module));
        this.repaint();
    }
    
    public Class[] getModuleTypes() {
        ModuleClassComboBoxModel cbm = (ModuleClassComboBoxModel) this.moduleComboBox.getModel();
        Class[] classes = new Class[cbm.getSize()];
        
        for (int i = 0; i < cbm.getSize(); ++i)
            classes[i] = cbm.getElementAt(i).getModuleClass();
        
        return classes;
    }
    
    static class SDDMChooser extends DefaultGLCapabilitiesChooser {
        public int chooseCapabilities(GLCapabilities desired,
                GLCapabilities[] available,
                int windowSystemRecommendedChoice) {
            int selection = super.chooseCapabilities(desired, available, windowSystemRecommendedChoice);
            
            // these are a more complicated mechainism - unnecessary unless something changes
            /*if (desired.getStereo() && !available[selection].getStereo() ) {
                //look through options for only those with stereo, and make the default chooser pick from those otions
                java.util.ArrayList<GLCapabilities> stereoList = new java.util.ArrayList<GLCapabilities>();
             
                for (GLCapabilities caps : available) {
                    if(caps.getStereo())
                        stereoList.add(caps);
                }
                int preferred = 0;
                for(int i = 0; i < stereoList.size();++i) {
                    if(stereoList.get(i) == available[windowSystemRecommendedChoice]) {
                        preferred = i;
                        break;
                    }
                }
             
                if (stereoList.isEmpty())
                    throw new SDDMException("Could not generate GL Context with Stereo as per request");
             
                GLCapabilities[] stereoCaps = new GLCapabilities[stereoList.size()];
                stereoList.toArray(stereoCaps);
                GLCapabilities resultCap = stereoCaps[super.chooseCapabilities(desired,stereoCaps,preferred)];
             
                for (int i = 0; i < available.length; i++) {
                    if(available[i] == resultCap) {
                        selection = i;
                        break;
                    }
                }
            }*/
            if (desired.getStereo() && !available[selection].getStereo() )  {
                if(JOptionPane.showConfirmDialog(null,"Could not generate GL Context with OpenGL Stereo as per request - exit?","OpenGL Stereo Error",JOptionPane.YES_NO_OPTION,JOptionPane.ERROR_MESSAGE)==JOptionPane.YES_OPTION)
                    System.exit(0);
            }
            
            if ((desired.getAlphaBits() == 8) && (available[selection].getAlphaBits() < 8))
                JOptionPane.showMessageDialog(null,"Alpha channel not available; transparency (and maybe selection) will not function.","Alpha Error",JOptionPane.WARNING_MESSAGE);
            
            if (desired.getSampleBuffers() && available[selection].getSampleBuffers()) {
                if(desired.getNumSamples() != available[selection].getNumSamples())
                    JOptionPane.showMessageDialog(null,"Cannot comply with Mulisampling request.  Requested number of samples:"+desired.getNumSamples()+", best available:"+available[selection].getNumSamples(),"Multisampling/FSAA Problem",JOptionPane.WARNING_MESSAGE);
            } else if (desired.getSampleBuffers())
                JOptionPane.showMessageDialog(null,"Mulisampling/Full-Scene Antialiasing not available.","Multisampling/FSAA Problem",JOptionPane.WARNING_MESSAGE);
            
            return selection;
        }
    }
    
    /*
     * Classes added to this MUST be suclasses of SDDModule
     */
    class ModuleClassComboBoxModel extends DefaultComboBoxModel {
        ModuleClassComboBoxModel() {
            this(true);
        }
        
        ModuleClassComboBoxModel(boolean loadDefaults) {
            super();
            //Test module is always loaded
            this.addElement(new ModuleClassWithTitle(TestModule.class));
            if (loadDefaults) {
                this.addElement(new ModuleClassWithTitle(HeightFieldModule.class));
                this.addElement(new ModuleClassWithTitle(StereoImageModule.class));
                this.addElement(new ModuleClassWithTitle(ParametricModule.class));
                this.addElement(new ModuleClassWithTitle(PointDrawingModule.class));
                this.addElement(new ModuleClassWithTitle(Scalar3DModule.class));
                this.addElement(new ModuleClassWithTitle(Vector3DModule.class));
                //ADD: add more built-in modules
            }
            
        }

        public void setSelectedItem(ModuleClassWithTitle anObject) {
            if(!SDDModule.class.isAssignableFrom(anObject.getModuleClass()))
                throw new SDDMException("Tried to add non-SDDModule class to a ModuleClassComboBoxModel");
            super.setSelectedItem(anObject);
        }
        
        public void removeElement(ModuleClassWithTitle anObject) {
            if(!SDDModule.class.isAssignableFrom(anObject.getModuleClass()))
                throw new SDDMException("Tried to add non-SDDModule class to a ModuleClassComboBoxModel");
            super.removeElement(anObject);
        }
        
        public int getIndexOf(ModuleClassWithTitle anObject) {
            if(!SDDModule.class.isAssignableFrom(anObject.getModuleClass()))
                throw new SDDMException("Tried to add non-SDDModule class to a ModuleClassComboBoxModel");
            return super.getIndexOf(anObject);
        }
        
        public void addElement(ModuleClassWithTitle anObject) {
            if(!SDDModule.class.isAssignableFrom(anObject.getModuleClass()))
                throw new SDDMException("Tried to add non-SDDModule class to a ModuleClassComboBoxModel");
            super.addElement(anObject);
        }
        
        public void insertElementAt(ModuleClassWithTitle anObject, int index) {
            if(!SDDModule.class.isAssignableFrom(anObject.getModuleClass()))
                throw new SDDMException("Tried to add non-SDDModule class to a ModuleClassComboBoxModel");
            super.insertElementAt(anObject, index);
        }
        
        public ModuleClassWithTitle getElementAt(int index) {
            return (ModuleClassWithTitle)super.getElementAt(index);
        }
        
        public ModuleClassWithTitle getSelectedItem() {
            return (ModuleClassWithTitle) super.getSelectedItem();
        }
    }
    
    class ModuleClassWithTitle {
        private Class moduleClass;
        private String title;
        
        /**
         * Instantiates a new  ModuleClassWithTitle
         * @param cl the class to associate with this object
         */
        public ModuleClassWithTitle(Class cl) {
            moduleClass = cl;
            title = null;
        }
        
        /**
         * Instantiates a new  ModuleClassWithTitle
         * @param cl the class to associate with this object
         * @param titleToUse the title to use for the toString() method
         */
        public ModuleClassWithTitle(Class cl, String titleToUse) {
            moduleClass = cl;
            title = titleToUse;
        }
        
        /**
         * Gets the module title
         * @return either the module title from the module itself, or the string specified in the constructor
         */
        public String toString() {
            String str = "";
            if (this.title == null) {
                try {
                    java.lang.reflect.Method ts = moduleClass.getMethod("moduleTitle");
                    str = (String) ts.invoke(null);
                } catch (Exception e) {
                    System.err.println("Exception getting name:"+e);
                    str = "Could not load title:"+moduleClass.toString();
                }
            } else
                str = this.title;
            return str;
        }
        
        /**
         * Retrieves the class object this encapsulates
         * @return the class associated with this object
         */
        public Class getModuleClass() {
            return moduleClass;
        }
        
        /**
         * Retrieves the string specified as the module title
         * @return the title to use on a call to toString, or null if the module title is to be used
         */
        public String getTitleString() {
            return this.title;
        }
        
        /**
         * Specifies the string to use as the module title
         * @param str a title, or null if the default module title should be used
         */
        public void setTitleString(String str) {
            this.title = str;
        }
    }
    
    //--------------------------Private methods ----------------------
    private static void offsetFromUnderlyingFrames(Component c, Frame[] underlyingFrames) {
        Point currPoint = c.getLocation();
        for(Frame f : underlyingFrames) {
            if (f.getLocation().equals(currPoint))  {
                int offsetLeft = f.getInsets().top;
                int offsetTop = offsetLeft;
                currPoint.setLocation(currPoint.getX()+offsetLeft+1,currPoint.getY()+offsetTop+1);
            }
        }
        c.setLocation(currPoint);
    }
    
    private static void loadJOGLibraries(File f) throws IOException {
        com.sun.opengl.impl.NativeLibLoader.disableLoading();
        
        if (!f.isDirectory())
            f = f.getParentFile();
        
        String libPath = System.getProperty("java.library.path");
        char sep = File.pathSeparatorChar;
        
        System.setProperty("java.library.path",libPath+sep+f.getCanonicalPath());
        
        System.load(f+"\\"+"jogl.dll");
        //System.load(f+"\\"+"jogl_cg.dll");
        System.load(f+"\\"+"jogl_awt.dll");
        
        //if (!f.isDirectory())
        //    f = f.getParentFile();
        
        //String libPath = System.getProperty("java.library.path");
        //char sep = File.pathSeparatorChar;
        
        //System.setProperty("java.library.path",libPath+sep+f.getCanonicalPath());
        //TODO:figure out why this doesn't work... ask in jogl forums
    }
    
    public static void addLibraryPath(String path) {
        Class sysclass = ClassLoader.class;
        
        try {
            String oldPath = System.getProperty("java.library.path");
            
            java.lang.reflect.Field field = sysclass.getDeclaredField("sys_paths");
            boolean accessible = field.isAccessible();
            if (!accessible)
                field.setAccessible(true);
            Object original = field.get(sysclass);
      /* Reset it to null so that whenever "System.loadLibrary" is
       * called it will be reconstructed with the changed value. */
            field.set(sysclass, null);
            
            /* Change the value and load the library. */
            System.setProperty("java.library.path", path+File.pathSeparator+oldPath);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    private static void setupNativeLibs() {
        com.sun.opengl.impl.NativeLibLoader.enableLoading();
        try {
            com.sun.opengl.impl.NativeLibLoader.loadCore();
            com.sun.opengl.impl.NativeLibLoader.loadAWTImpl();
            /*try {
                com.sun.opengl.impl.NativeLibLoader.loadDRIHack();
            } catch (UnsatisfiedLinkError ignore) {
                //if dri hack doesn't load, but the others do, we assume that its not supposed to.
            }*/
        } catch (UnsatisfiedLinkError e) {
            if( JOptionPane.showConfirmDialog(null,"Could not find JOGL native Libraries - try to locate library?","JOGL Natives not Found",JOptionPane.YES_NO_OPTION,JOptionPane.ERROR_MESSAGE) != JOptionPane.YES_OPTION)
                System.exit(1);
            else {
                JFileChooser jfc = new JFileChooser();
                jfc.setMultiSelectionEnabled(false);
                jfc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
                jfc.setAcceptAllFileFilterUsed(false);
                jfc.setFileFilter(new javax.swing.filechooser.FileFilter() {
                    final String matchRegex = "jogl|jogl_awt|jogl_drihack";
                    public boolean accept(File pathname) {
                        java.util.regex.Pattern p = java.util.regex.Pattern.compile(matchRegex);
                        java.util.regex.Matcher m = p.matcher(pathname.toString());
                        return pathname.isDirectory()||m.find();
                    }
                    public String getDescription() {
                        return "JOGL Native Libraries";
                    }
                    
                });
                
                if( jfc.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
                    try {
                        loadJOGLibraries(jfc.getSelectedFile());
                    } catch (IOException ioe) {
                        JOptionPane.showMessageDialog(null,"I/O Problem loading native libs; Exiting...\n"+e,"Couldn't load Native Libraries",JOptionPane.ERROR_MESSAGE);
                        System.exit(1);
                    }
                } else {
                    JOptionPane.showMessageDialog(null,"No files selected for Native libraries; Exiting...","No Native Libraries",JOptionPane.ERROR_MESSAGE);
                    System.exit(1);
                };
            }
        }
    }
    
    private static boolean isWindows(String os) {
        java.util.regex.Pattern p = java.util.regex.Pattern.compile("windows",java.util.regex.Pattern.CASE_INSENSITIVE);
        return p.matcher(os).find();
    }
    
    
}
