/*
 * TestModulePanel.java
 *
 * Created on June 13, 2006, 2:27 AM
 */

package sddm.modules;

import java.awt.event.MouseEvent;
import net.java.joglutils.*;
import sddm.*;
import sddm.SDDModule;
import sddm.SDDModuleControlPanel;

/**
 *
 * @author  Erik J. Tollerud
 */
public class TestModulePanel extends SDDModuleControlPanel {
    private TestModule mod;
    
    /** Creates new form TestModulePanel */
    public TestModulePanel(TestModule module) {
        this(module, module.getCamera());
    }
    public TestModulePanel(TestModule module, StereoCamera camera) {
        super(camera);
        this.mod = module;
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        textCheckBox = new javax.swing.JCheckBox();
        renderColorButton = new javax.swing.JButton();
        matrixButton = new javax.swing.JButton();
        bgColorButton = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jComboBox1 = new javax.swing.JComboBox();
        jFormattedTextField1 = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        jLabel1 = new javax.swing.JLabel();
        jCheckBox1 = new javax.swing.JCheckBox();
        matrixCheckBox = new javax.swing.JCheckBox();
        tileCheckBox = new javax.swing.JCheckBox();
        tileTextField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getIntegerInstance());
        tileScaleTextField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        jLabel2 = new javax.swing.JLabel();
        transformButton = new javax.swing.JButton();

        textCheckBox.setSelected(true);
        textCheckBox.setText("showText?");
        textCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        textCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        textCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textCheckBoxActionPerformed(evt);
            }
        });

        renderColorButton.setText("Choose Render Color...");
        renderColorButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                renderColorButtonActionPerformed(evt);
            }
        });

        matrixButton.setText("Matrix...");
        matrixButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                matrixButtonActionPerformed(evt);
            }
        });

        bgColorButton.setText("Choose BG Color...");
        bgColorButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bgColorButtonActionPerformed(evt);
            }
        });

        jButton1.setText("Set Target to Origin");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Teapot", "Sphere", "Cube", "Cone", "Dodecahedron", "Icosahedron", "Octahedron", "Tetrahedron" }));
        jComboBox1.setSelectedIndex(mod.comboBoxIndex);
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });

        jFormattedTextField1.setText("test");
        jFormattedTextField1.setValue(mod.lineWidth);
        jFormattedTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextField1ActionPerformed(evt);
            }
        });

        jLabel1.setText("Line Size");

        jCheckBox1.setSelected(mod.displayInfo);
        jCheckBox1.setText("err info?");
        jCheckBox1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });

        matrixCheckBox.setSelected(mod.useMatrix);
        matrixCheckBox.setText("use matrix?");
        matrixCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        matrixCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        matrixCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                matrixCheckBoxActionPerformed(evt);
            }
        });

        tileCheckBox.setSelected(mod.tile);
        tileCheckBox.setText("tile?");
        tileCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        tileCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        tileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tileCheckBoxActionPerformed(evt);
            }
        });

        tileTextField.setText("test");
        tileTextField.setValue(mod.radialUnitCells);
        tileTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tileTextFieldActionPerformed(evt);
            }
        });

        tileScaleTextField.setText("test");
        tileScaleTextField.setValue(mod.tileScale);
        tileScaleTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tileScaleTextFieldActionPerformed(evt);
            }
        });

        jLabel2.setText("tile scale:");

        transformButton.setText("Transform");

        transformButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                transformButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(textCheckBox)
                    .add(jCheckBox1)
                    .add(transformButton))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, renderColorButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 159, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(10, 10, 10)
                                .add(jLabel1)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jFormattedTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 57, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(bgColorButton)
                            .add(layout.createSequentialGroup()
                                .add(tileCheckBox)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(tileTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 57, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jLabel2)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(layout.createSequentialGroup()
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                .add(layout.createSequentialGroup()
                                    .add(28, 28, 28)
                                    .add(matrixButton)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .add(matrixCheckBox))
                                .add(layout.createSequentialGroup()
                                    .add(7, 7, 7)
                                    .add(jButton1)))
                            .addContainerGap())
                        .add(layout.createSequentialGroup()
                            .add(26, 26, 26)
                            .add(jComboBox1, 0, 96, Short.MAX_VALUE)
                            .add(70, 70, 70)))
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(tileScaleTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 57, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(renderColorButton)
                            .add(matrixButton)
                            .add(matrixCheckBox))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(bgColorButton)
                            .add(jButton1)))
                    .add(layout.createSequentialGroup()
                        .add(29, 29, 29)
                        .add(textCheckBox)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jComboBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jFormattedTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(jLabel1))
                    .add(jCheckBox1))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(tileCheckBox)
                    .add(tileTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel2)
                    .add(tileScaleTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(transformButton))
                .addContainerGap(25, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void transformButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_transformButtonActionPerformed
        if (transformButton.getMouseListeners().length < 2 ) {
            java.util.EventListener translis = this.cam.getTransformListener();
            transformButton.addMouseListener((java.awt.event.MouseListener)translis);
            transformButton.addMouseMotionListener((java.awt.event.MouseMotionListener)translis);
            transformButton.addMouseMotionListener(new java.awt.event.MouseMotionListener() {
                public void mouseDragged(MouseEvent e) {
                    redisplayParent();
                }
                public void mouseMoved(MouseEvent e) {
                }
            });
            transformButton.addMouseListener(new java.awt.event.MouseListener() {
                public void mouseClicked(MouseEvent e) {
                    redisplayParent();
                }
                public void mouseEntered(MouseEvent e) {
                }
                public void mouseExited(MouseEvent e) {
                }
                public void mousePressed(MouseEvent e) {
                }
                public void mouseReleased(MouseEvent e) {
                }
            });
        }
    }//GEN-LAST:event_transformButtonActionPerformed

    private void tileScaleTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tileScaleTextFieldActionPerformed
        mod.tileScale = ((Number)tileScaleTextField.getValue()).floatValue();
        mod.recompile();
        this.redisplayParent();
    }//GEN-LAST:event_tileScaleTextFieldActionPerformed
    
    private void tileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tileCheckBoxActionPerformed
        mod.tile = tileCheckBox.isSelected();
        mod.recompile();
        this.redisplayParent();
    }//GEN-LAST:event_tileCheckBoxActionPerformed

    private void tileTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tileTextFieldActionPerformed
        mod.radialUnitCells = ((Number)tileTextField.getValue()).intValue();
        mod.recompile();
        this.redisplayParent();
    }//GEN-LAST:event_tileTextFieldActionPerformed

    private void matrixCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_matrixCheckBoxActionPerformed
        mod.useMatrix = matrixCheckBox.isSelected();
        mod.recompile();
        this.redisplayParent();
    }//GEN-LAST:event_matrixCheckBoxActionPerformed

    private void matrixButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_matrixButtonActionPerformed
        javax.swing.JPanel panel = new javax.swing.JPanel();
        javax.swing.JFormattedTextField[] jftfs = new javax.swing.JFormattedTextField[16];
        for (int i = 0; i < jftfs.length; ++i) {
            jftfs[i] = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
            jftfs[i].setValue(0.0f);
        }
        
        //use current matrix initially
        mod.mat.transpose();
        float[] modMat = mod.getMatrixAsArray();
        for (int i = 0; i < modMat.length;++i)
            jftfs[i].setValue(modMat[i]);
        mod.mat.transpose();
        
        panel.setLayout(new java.awt.GridLayout(4,4));
        
        for (javax.swing.JFormattedTextField f : jftfs) {
            java.awt.Dimension dim = f.getPreferredSize();
            dim.width = dim.width+30;
            f.setPreferredSize(dim);
            panel.add(f);
            
        }
        
        JPanelDialog jpd = new JPanelDialog("Settings For Matrix",panel);
         panel.setSize(panel.getPreferredSize());
        jpd.setSize(jpd.getPreferredSize().width+125,jpd.getPreferredSize().height);
        if (jpd.showAsModal()) {
            float[] matrix = new float[16];
            for (int i = 0; i < matrix.length; ++i)
                matrix[i] =((Number) jftfs[i].getValue() ).floatValue();
            javax.vecmath.Matrix4f mat = new javax.vecmath.Matrix4f(matrix);
            System.err.println("setting matrix:"+mat);
            mod.mat = mat;
        }
        mod.recompile();
        this.redisplayParent();
        
    }//GEN-LAST:event_matrixButtonActionPerformed

    private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
        mod.displayInfo = jCheckBox1.isSelected();
    }//GEN-LAST:event_jCheckBox1ActionPerformed
    
    private void jFormattedTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextField1ActionPerformed
        mod.lineWidth = ((Number)jFormattedTextField1.getValue()).floatValue();
        mod.recompile();
        this.redisplayParent();
    }//GEN-LAST:event_jFormattedTextField1ActionPerformed
    
    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        mod.comboBoxIndex = jComboBox1.getSelectedIndex();
        mod.recompile();
        this.redisplayParent();
    }//GEN-LAST:event_jComboBox1ActionPerformed
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        cam.setTargetPoint(0,0,0);
        this.redisplayParent();
    }//GEN-LAST:event_jButton1ActionPerformed
    
    private void bgColorButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bgColorButtonActionPerformed
        java.awt.Color c = javax.swing.JColorChooser.showDialog(this,"Color for Test Module",mod.getBackgroundColor());
        if (c!=null)
            mod.setBackgroundColor(c);
        mod.recompile();
        this.redisplayParent();
    }//GEN-LAST:event_bgColorButtonActionPerformed
        
    private void textCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textCheckBoxActionPerformed
        mod.showText = textCheckBox.isSelected();
        mod.recompile();
        this.redisplayParent();
        
    }//GEN-LAST:event_textCheckBoxActionPerformed
    
    private void renderColorButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_renderColorButtonActionPerformed
        java.awt.Color c = javax.swing.JColorChooser.showDialog(this,"Color for Test Module",mod.renderColor);
        if (c!=null)
            mod.renderColor = c;
        mod.recompile();
        this.redisplayParent();
    }//GEN-LAST:event_renderColorButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bgColorButton;
    private javax.swing.JButton jButton1;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JFormattedTextField jFormattedTextField1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JButton matrixButton;
    private javax.swing.JCheckBox matrixCheckBox;
    private javax.swing.JButton renderColorButton;
    private javax.swing.JCheckBox textCheckBox;
    private javax.swing.JCheckBox tileCheckBox;
    private javax.swing.JFormattedTextField tileScaleTextField;
    private javax.swing.JFormattedTextField tileTextField;
    private javax.swing.JButton transformButton;
    // End of variables declaration//GEN-END:variables
    public void setModule(TestModule module) {
        this.mod = module;
    }
    public TestModule getModule() {
        return this.mod;
    }
    public void moduleSettingsToPanel(SDDModule module) {
        TestModule tm = (TestModule)module;
        textCheckBox.setSelected(tm.showText);
        mod.showText = tm.showText;
        mod.renderColor = tm.renderColor;
        jComboBox1.setSelectedIndex(mod.comboBoxIndex);
        matrixCheckBox.setSelected(tm.useMatrix);
        tileTextField.setValue(tm.radialUnitCells);
        tileScaleTextField.setValue(tm.tileScale);
        tileCheckBox.setSelected(tm.tile);
        
    }
    
    public SDDModule panelToModuleSettings(SDDModule module) {
        TestModule out = (TestModule)module;
        if (module==null)
            out = new TestModule();
        out.renderColor = mod.renderColor;
        out.showText = mod.showText;
        out.useMatrix = matrixCheckBox.isSelected();
        out.radialUnitCells = ((Number)this.tileTextField.getValue()).intValue();
        out.tileScale = ((Number)this.tileTextField.getValue()).floatValue();
        out.tile = tileCheckBox.isSelected();
        return out;
    }
}
